unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, shellapi, ComCtrls, Buttons;

type
  TformMenuPrincipal = class(TForm)
    LWEB: TLabel;
    PageControl1: TPageControl;
    tabInfo: TTabSheet;
    tabCambiar: TTabSheet;
    dlAbrir: TOpenDialog;
    dlGuardar: TSaveDialog;
    lInfo: TMemo;
    bGuardar: TButton;
    Button1: TButton;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    lsAtributos: TComboBox;
    GroupBox2: TGroupBox;
    txtFichero: TEdit;
    Label2: TLabel;
    bSeleccionar: TButton;
    bInformacionFichero: TButton;
    bCambiar: TBitBtn;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    opActivar: TRadioButton;
    opDesactivar: TRadioButton;
    procedure bSeleccionarClick(Sender: TObject);
    procedure bInformacionFicheroClick(Sender: TObject);

    //para arrastrar y soltar
    procedure SoltarFichero  (var Msg: TWMDropFiles); message WM_DROPFILES;
  
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure bGuardarClick(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
    procedure bCambiarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

//si se utilizar drag and drop (arrastrar y soltar)
procedure TformMenuPrincipal.SoltarFichero (var Msg : TWMDropFiles);
var
  CFileName: array[0..MAX_PATH] of Char;
begin
  try
    if DragQueryFile(Msg.Drop, 0, CFileName, MAX_PATH) > 0 then
    begin
      txtFichero.Text := CFileName;
      bInformacionFicheroClick(nil);
      Msg.Result := 0;
    end;
  finally
    DragFinish(Msg.Drop); //finaliza arrastrar y soltar
  end;
end;

function cambiarAtributo (fichero : string; atributo : string;
    activar : boolean) : boolean;
var
  resultado : boolean;
  atributos: Cardinal;
  atributoNumero : DWORD;
begin
  resultado := false;

  atributos := GetFileAttributes(PChar(fichero));


  if atributo = 'Oculto' then
    atributoNumero := FILE_ATTRIBUTE_HIDDEN;
  if atributo = 'Sistema' then
    atributoNumero := FILE_ATTRIBUTE_SYSTEM;
  if atributo = 'Slo lectura' then
    atributoNumero := FILE_ATTRIBUTE_READONLY;
  if atributo = 'Listo para archivar' then
    atributoNumero := FILE_ATTRIBUTE_ARCHIVE;
  if atributo = 'Fuera de lnea' then
    atributoNumero := FILE_ATTRIBUTE_OFFLINE;
  if atributo = 'Temporal' then
    atributoNumero := FILE_ATTRIBUTE_TEMPORARY;
  if atributo = 'Normal' then
    atributoNumero := FILE_ATTRIBUTE_NORMAL;
  if atributo = 'No indexar' then
    atributoNumero := $00002000;

  if activar then
  begin
    if (atributos and atributoNumero) > 0 then
      Result := false
    else
      resultado := SetFileAttributes (PChar(fichero), atributos + atributoNumero);
  end
  else
  begin
    if (atributos and atributoNumero) > 0 then
      resultado := SetFileAttributes (PChar(fichero), atributos - atributoNumero)
    else
      Result := false;
  end;

  Result := resultado;
end;


function versionFichero (const FileName: TFileName; var Major, Minor, Release, Build : word): boolean;
var
  size, len: longword;
  handle: THandle;
  buffer: pchar;
  pinfo: ^VS_FIXEDFILEINFO;
begin
  Result := False;
  size := GetFileVersionInfoSize(Pointer(FileName), handle);
  if size > 0 then begin
    GetMem(buffer, size);
    if GetFileVersionInfo(Pointer(FileName), 0, size, buffer)
    then
      if VerQueryValue(buffer, '\', pointer(pinfo), len) then begin
        Major   := HiWord(pinfo.dwFileVersionMS);
        Minor   := LoWord(pinfo.dwFileVersionMS);
        Release := HiWord(pinfo.dwFileVersionLS);
        Build   := LoWord(pinfo.dwFileVersionLS);
        Result  := True;
      end;
    FreeMem(buffer);
  end;
end;


procedure TformMenuPrincipal.bSeleccionarClick(Sender: TObject);
begin
  dlAbrir.Title := 'Seleccione el fichero...';
  dlAbrir.Filter := 'Aplicacin (*.exe)|*.exe|Librera (*.dll)|*.dll|Com (*.com)|*.com|Todos los archivos (*.*)|*.*';
  if dlAbrir.Execute then
  begin
    txtFichero.Text := dlAbrir.FileName;
    bInformacionFicheroClick(nil);
  end;
end;

function obtenerInfoFichero (info : string; fichero : string) : string;
type
  PaLeerBuffer = array [0..MAX_PATH] of char;
var
  Size, Size2 : DWord;
  Pt, Pt2 : Pointer;
  Idioma : string;
begin
  Result := '';
  Size := GetFileVersionInfoSize(PChar (fichero), Size2);
  if Size > 0 then
  begin
    GetMem (Pt, Size);
    if GetFileVersionInfo (PChar (fichero), 0, Size, Pt) then
    begin
      VerQueryValue( Pt, '\VarFileInfo\Translation',Pt2, Size2);
      Idioma:=IntToHex( DWord(Pt2^) ,8 );
      Idioma:=Copy(Idioma,5,4)+Copy(Idioma,1,4);
      VerQueryValue( Pt,Pchar('\StringFileInfo\'+Idioma+'\'+info),Pt2, Size2);
      if Size2 > 0 then
      begin
       Result:=Copy(PaLeerBuffer(Pt2^),1,Size2);
      end
      else
        result := '';
      FreeMem (Pt);
    end;
  end
  else
    result := '';
end;

function tamanoFichero (sFileToExamine: string) : Integer;
var
  SearchRec: TSearchRec;
  sgPath: string;
  inRetval, I1: Integer;
begin
  sgPath := ExpandFileName(sFileToExamine);
  try
    inRetval := FindFirst(ExpandFileName(sFileToExamine), faAnyFile, SearchRec);
    if inRetval = 0 then
      I1 := SearchRec.Size
    else
      I1 := -1;
  finally
    SysUtils.FindClose(SearchRec);
  end;
  Result := I1;
end;


function quitarExtension (nombreFichero : string) : string;
begin
  result := copy(ExtractFileName(nombreFichero), 1,
      pos(ExtractFileExt(nombreFichero), ExtractFileName(nombreFichero)) - 1);
end;


function obtenerFechasFichero (const FileName: string; var Created: TDateTime;
         var Accessed: TDateTime; var Modified: TDateTime): Boolean;
var
  h: THandle;
  Info1, Info2, Info3: TFileTime;
  SysTimeStruct: SYSTEMTIME;
  TimeZoneInfo: TTimeZoneInformation;
  Bias: Double;
begin
  Result := False;
  Bias   := 0;
  h      := FileOpen(FileName, fmOpenRead or fmShareDenyNone);
  if h > 0 then
  begin
    try
      if GetTimeZoneInformation(TimeZoneInfo) <> $FFFFFFFF then
        Bias := TimeZoneInfo.Bias / 1440; // 60x24
      GetFileTime(h, @Info1, @Info2, @Info3);
      if FileTimeToSystemTime(Info1, SysTimeStruct) then
        Created := SystemTimeToDateTime(SysTimeStruct) - Bias;
      if FileTimeToSystemTime(Info2, SysTimeStruct) then
        Accessed := SystemTimeToDateTime(SysTimeStruct) - Bias;
      if FileTimeToSystemTime(Info3, SysTimeStruct) then
        Modified := SystemTimeToDateTime(SysTimeStruct) - Bias;
      Result := True;
    finally
      FileClose(h);
    end;
  end;
end;

function obtenerAtributos (fichero : string) : DWORD;
begin
  result := GetFileAttributes(pchar(fichero));
end;


procedure TformMenuPrincipal.bInformacionFicheroClick(Sender: TObject);
var
  major, minor, release, build, atributos : word;
  version : string;
  sizeFichero : Longint;
  fechaCreacion, ultimoAcceso, ultimaModificacion : TDateTime;
begin
  if FileExists(txtFichero.Text) then
  begin
    tabInfo.Show;
    if versionFichero(txtFichero.Text,major,minor,release, build) then
      version := Format('Versin: %d.%d.%d.%d', [Major, Minor, Release, Build])
    else
      version := 'Versin no disponible';
    lInfo.Clear;
    lInfo.Lines.Add('Nombre: ' + ExtractFileName(txtFichero.Text));
    lInfo.Lines.Add('Extensin: ' + ExtractFileExt(txtFichero.Text));
    lInfo.Lines.Add('Ubicacin (carpeta): ' + ExtractFilePath(txtFichero.Text));
    lInfo.Lines.Add('Nombre sin extensin: ' + quitarExtension (extractfilename(txtFichero.text)));
    lInfo.Lines.Add('Unidad: ' + ExtractFileDrive(txtFichero.text));
    lInfo.Lines.Add(version);
    lInfo.Lines.Add('Compaa: ' + obtenerInfoFichero ('CompanyName', txtFichero.Text));
    lInfo.Lines.Add('Descripcin: ' + obtenerInfoFichero ('FileDescription', txtFichero.Text));
    lInfo.Lines.Add('Nombre interno: ' + obtenerInfoFichero ('InternalName', txtFichero.Text));
    lInfo.Lines.Add('Derechos de copia: ' + obtenerInfoFichero ('LegalCopyright', txtFichero.Text));
    lInfo.Lines.Add('Nombre original: ' + obtenerInfoFichero ('OriginalFilename', txtFichero.Text));
    lInfo.Lines.Add('Nombre producto: ' + obtenerInfoFichero ('ProductName', txtFichero.Text));
    lInfo.Lines.Add('Versin producto: ' + obtenerInfoFichero ('ProductVersion', txtFichero.Text));
    lInfo.Lines.Add('Versin fichero: ' + obtenerInfoFichero ('FileVersion', txtFichero.Text));
    lInfo.Lines.Add('Comentarios: ' + obtenerInfoFichero ('Comments', txtFichero.Text));
    sizeFichero := tamanoFichero(txtFichero.Text);
    if sizeFichero = 0 then
      lInfo.Lines.Add('Tamao (Bytes): Para obtener el tamao el fichero debe estar cerrado.')
    else
      lInfo.Lines.Add('Tamao (Bytes): ' + IntToStr(tamanoFichero(txtFichero.Text)));

    //fechas
    if obtenerFechasFichero (txtFichero.Text, fechaCreacion, ultimoAcceso, ultimaModificacion) then
    begin
      lInfo.Lines.Add('Fecha creacin: ' + DateToStr (fechaCreacion));
      lInfo.Lines.Add('Fecha ltimo acceso: ' + DateToStr(ultimoAcceso));
      lInfo.Lines.Add('Fecha modificacin: ' + DateToStr(ultimaModificacion));
    end;

    //atributos
    atributos := obtenerAtributos (PChar(txtFichero.Text));
    if (atributos and FILE_ATTRIBUTE_ARCHIVE) > 0 then
      lInfo.lines.Add('Atributo listo para archivar: S')
    else
      lInfo.lines.Add('Atributo listo para archivar: No');

    if (atributos and FILE_ATTRIBUTE_DIRECTORY > 0) then
      lInfo.lines.Add('Atributo directorio: S')
    else
      lInfo.lines.Add('Atributo directorio: No');

    if (atributos and FILE_ATTRIBUTE_HIDDEN > 0) then
      lInfo.lines.Add('Atributo oculto: S')
    else
      lInfo.lines.Add('Atributo oculto: No');

    if (atributos and FILE_ATTRIBUTE_OFFLINE > 0)  then
      lInfo.lines.Add('Atributo fuera de lnea: S')
    else
      lInfo.lines.Add('Atributo fuera de lnea: No');

    if (atributos and FILE_ATTRIBUTE_TEMPORARY > 0)  then
      lInfo.lines.Add('Atributo temporal: S')
    else
      lInfo.lines.Add('Atributo temporal: No');

    if (atributos and FILE_ATTRIBUTE_READONLY > 0)  then
      lInfo.lines.Add('Atributo slo lectura: S')
    else
      lInfo.lines.Add('Atributo slo lectura: No');

    if (atributos and FILE_ATTRIBUTE_SYSTEM > 0)  then
      lInfo.lines.Add('Atributo sistema: S')
    else
      lInfo.lines.Add('Atributo sistema: No');

    if (atributos and FILE_ATTRIBUTE_NORMAL > 0)  then
      lInfo.lines.Add('Atributo normal: S')
    else
      lInfo.lines.Add('Atributo normal: No');

    if (atributos and FILE_ATTRIBUTE_COMPRESSED) > 0 then
      lInfo.lines.Add('Atributo comprimido: S')
    else
      lInfo.lines.Add('Atributo comprimido: No');

    if (atributos and $00004000) > 0 then
      lInfo.lines.Add('Atributo encriptado: S')
    else
      lInfo.lines.Add('Atributo encriptado: No');

    if (atributos and $00002000) > 0 then
      lInfo.lines.Add('Atributo permitir indexar: No')
    else
      lInfo.lines.Add('Atributo permitir indexar: S');

    bGuardar.SetFocus;
  end
  else
    MessageDlg('El fichero seleccionado no existe.', mtWarning, [mbok], 0);
end;


function GetFileTimes(const FileName: string; var Created: TDateTime;
var Accessed: TDateTime; var Modified: TDateTime): Boolean;
var
  h: THandle;
  Info1, Info2, Info3: TFileTime;
  SysTimeStruct: SYSTEMTIME;
  TimeZoneInfo: TTimeZoneInformation;
  Bias: Double;
begin
  Result := False;
  Bias   := 0;
  h      := FileOpen(FileName, fmOpenRead or fmShareDenyNone);
  if h > 0 then
  begin
    try
      if GetTimeZoneInformation(TimeZoneInfo) <> $FFFFFFFF then
        Bias := TimeZoneInfo.Bias / 1440; // 60x24
      GetFileTime(h, @Info1, @Info2, @Info3);
      if FileTimeToSystemTime(Info1, SysTimeStruct) then
        Created := SystemTimeToDateTime(SysTimeStruct) - Bias;
      if FileTimeToSystemTime(Info2, SysTimeStruct) then
        Accessed := SystemTimeToDateTime(SysTimeStruct) - Bias;
      if FileTimeToSystemTime(Info3, SysTimeStruct) then
        Modified := SystemTimeToDateTime(SysTimeStruct) - Bias;
      Result := True;
    finally
      FileClose(h);
    end;
  end;
end;


procedure TformMenuPrincipal.FormCreate(Sender: TObject);
begin
  //permitimos arrastrar y soltar
  DragAcceptFiles(Handle, True);
  if ParamCount > 0 then
  begin
    if ParamStr(1) <> '' then
    begin
      if FileExists(ParamStr(1)) then
      begin
        txtFichero.Text := ParamStr(1);
        bInformacionFicheroClick(nil);
      end;
    end;
  end
  else
    txtFichero.Text := '';
end;

procedure TformMenuPrincipal.Button1Click(Sender: TObject);
begin
  close;
end;

procedure TformMenuPrincipal.bGuardarClick(Sender: TObject);
begin
  dlGuardar.Title := 'Guardar informacin de fichero...';
  dlGuardar.FileName := ChangeFileExt(ExtractFileName(txtFichero.Text), '.txt');
  if dlGuardar.Execute then
    lInfo.Lines.SaveToFile (dlGuardar.FileName);  
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.bCambiarClick(Sender: TObject);
begin
  if FileExists(txtFichero.Text) then
  begin
    if lsAtributos.Text = '' then
    begin
      MessageDlg('Debe indicar el atributo a modificar.',
          mtInformation, [mbok], 0);
      tabCambiar.Show;
      lsAtributos.SetFocus;
    end
    else
    begin
      if not opActivar.Checked and not opDesactivar.Checked then
      begin
        MessageDlg('Debe indicar si desea activar o desactivar el atributo',
            mtInformation, [mbok], 0);
        tabCambiar.Show;
        opActivar.SetFocus;
      end
      else
      begin
        if FileExists(txtFichero.Text) then
        begin
          if cambiarAtributo(txtFichero.Text, lsAtributos.Text, opActivar.Checked) then
            MessageDlg('El atributo [' + lsAtributos.Text +
                '] ha sido cambiado correctamente para el fichero:' +
                chr(13) + txtFichero.Text,
                mtInformation, [mbok], 0)
          else
            MessageDlg('El atributo [' + lsAtributos.Text +
                '] no ha podido ser cambiado.',
                mtWarning, [mbok], 0);
        end;
      end;
    end;
  end
  else
  begin
    MessageDlg('Debe indicar un fichero existente al que se le cambiar el atributo.',
        mtInformation, [mbok], 0);
    txtFichero.SetFocus;
  end;
end;

procedure TformMenuPrincipal.FormShow(Sender: TObject);
begin
  tabInfo.Show;
end;

end.
